// =========================================================================================================
// MPS - MultiPlayer Scripting Framework by [OCB]EightySix
// Version Release 1.02
   diag_log format ["###### %1 MPS.INIT ######", missionName];
   diag_log [diag_frameno, diag_ticktime, time, "Executing init_mps.sqf"];
// =========================================================================================================

// DeBuggint MPS
	mps_debug = false;

// Declare a mission name and credits
	mps_mission_name = "Patrol Ops 2";
	mps_credits = "Patrol Ops 2 By [OCB]EightySix";

// =========================================================================================================
//	Modify these configs per your preferences
// =========================================================================================================

// Enable A2, Arrowhead, AAW backpack
	mps_a2	= true;		// Set false to turn off A2 content
	mps_oa	= true;		// Set false to turn off OA content
	mps_aaw	= false;	// Set false to turn off AAW Backpack

// Set the sides
// NOTE: make sure side = faction type, e.g. [east,"BIS_US"] will result in US troops killing each other.
// Faction list can be found in the configuration files to choose from which ones to use.

	SIDE_A = [west,"SFP_SWE"];	// Player Side
	SIDE_B = [east,"BIS_TK_INS"];	// Enemy Side
	SIDE_C = [east,"BIS_TK_GUE"];	// Insurgent Side

// Civillian Types
	ALICE_MODULE =	["AliceManager"];	// Alice = Chernarus, Alice2 = Takistan

// Set total number of expected players
	mps_ref_playercount = 32;	// Max number of players

// Set details for mission intro / outro music
	mps_mission_intro = "sfp_track4";
	mps_mission_outro = "EP1_Track07";

// =========================================================================================================
//	Only modify these configs if you know what you are doing **** Thanks BON!!!
// =========================================================================================================

	mps_params_armour	= [0,3];	// [min,max] number of armour	vs. player number
	mps_params_aa		= [0,3];	// [min,max] number of anti air	vs. player number
	mps_params_apc		= [0,4];	// [min,max] number of apcs	vs. player number
	mps_params_car		= [2,5];	// [min,max] number of light vehicles	vs. player number
	mps_params_inf		= [2,9];	// [min,max] number of infantry	vs. player number

	mps_params_muliply	= MISSIONDIFF;	// Difficulty Variable from parameters

// =========================================================================================================
//	DO NOT TOUCH CODE BELOW THIS LINE
// =========================================================================================================

// File path folder
	mps_path = "mps\";

// Set Default Variables in case of not being declared
	if(isNil "mps_hud_active") then { mps_hud_active = false; };
	if(isNil "mps_airdrop_enable") then { mps_airdrop_enable = false; };
	if(isNil "mps_airdrop_enable") then {mps_airdrop_enable = false};
	if(isNil "mps_ace_wounds") then {mps_ace_wounds = false};
	if(isnil "mps_class_limit") then {mps_class_limit = false};
	if(isNil "mps_liftchopper_enable") then {mps_liftchopper_enable = false};
	if(isNil "mps_sys_rank") then {mps_sys_rank = false};
	if(isNil "mps_recruitable_ai") then {mps_recruitable_ai = false};
	if(isNil "mps_moveable_unload") then {mps_moveable_unload = ""};
	if(isNil "mps_lock_action") then {mps_lock_action = false};
	if(isNil "mps_rank_sys_enabled") then {mps_rank_sys_enabled = false};
	if(isNil "mps_acre_enabled") then {mps_acre_enabled = false};


// Load the Configruation Variables
	[] call compile preprocessFileLineNumbers (mps_path+"config\config_ammobox.sqf");
	[] call compile preprocessFileLineNumbers (mps_path+"config\config_units.sqf");
	[] call compile preprocessFileLineNumbers (mps_path+"config\config_vehicles.sqf");
	[] call compile preprocessFileLineNumbers (mps_path+"config\config_backpacks.sqf");
	[] call compile preprocessFileLineNumbers (mps_path+"func\mps_func_functions.sqf");

// FUNCTIONS LISTS which are called when needed.
	mps_weapons_list		= compile preprocessFileLineNumbers (mps_path+"config\config_armoury.sqf");
	mps_cleanup			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_cleanup.sqf");
	mps_get_position		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_get_position.sqf");
	mps_getnearbylocation		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_nearbylocation.sqf");
	mps_getEnterableHouses 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_getenterablehouses.sqf");
	mps_getRandomElement		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_getrandomarrayelement.sqf");
	mps_getArrayPermutation		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_getarraypermutation.sqf");
	mps_getFlatArea 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_getflatarea.sqf");
	mps_getnearestroad		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_getnearestroad.sqf");
	mps_new_position		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_new_position.sqf");
	mps_object_c4only		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_c4only.sqf");
	mps_random_position		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_random_location.sqf");
	mps_setdate 			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_date_set.sqf");
	mps_adv_hint			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_advhint.sqf");
	mps_tasks_init			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_taskmaster.sqf");
	mps_class_check			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_class_check.sqf");
	mps_intro			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_intro_sequence.sqf");
	mps_intro_camera		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_intro_camera.sqf");
	mps_outro			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_outro_sequence.sqf");
	mps_outro_camera		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_outro_camera.sqf");
	mps_player_killed		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_respawn_killed.sqf");
	mps_func_death_pos		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_respawn_deathpos.sqf");
	mps_func_death_cam		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_respawn_deathcam.sqf");
	mps_func_respawn		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_respawn_select.sqf");
	mps_respawn_delay		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_respawn_delay.sqf");
	mps_respawn_dialog_upd 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_respawn_dialog.sqf");
	mps_respawn_gear 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_respawn_gear.sqf");
	mps_get_new_type 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_mhq_gettype.sqf");
	mps_mhq_toggle			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_mhq_toggle.sqf");
	mps_mhq_respawn			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_mhq_respawn.sqf");
	mps_mhq_update			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_mhq_update.sqf");
	mps_rank_promote		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_rank_promote.sqf");
	mps_rank_demote			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_rank_demote.sqf");
	mps_rank_update			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_rank_update.sqf");
	mps_rank_proxy			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_rank_proximity.sqf");
	mps_rank_init			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_rank_system.sqf");
	mps_rank_hud			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_rank_hud.sqf");
	mps_func_hud_aimpoint		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_hud_aimpoint.sqf");
	mps_func_hud_3d			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_hud_3d.sqf");
	mps_func_hud_menu_update	= compile preprocessFileLineNumbers (mps_path+"func\mps_func_hud_menu_update.sqf");
	mps_func_hud_teamlist		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_hud_teamlist.sqf");
	mps_func_calculate_alpha	= compile preprocessFileLineNumbers (mps_path+"func\mps_func_calculate_alpha.sqf");
	mps_func_display_getnameNrank	= compile preprocessFileLineNumbers (mps_path+"func\mps_func_getnamerank.sqf");
	mps_func_keyspressed		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_keypressed.sqf");
	mps_ammobox			= compile preprocessFileLineNumbers (mps_path+"func\mps_func_ammobox_init.sqf");
	mps_fill_ammobox		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_ammobox_fill.sqf");
	mps_ammobox_remove		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_ammobox_remove.sqf");
	mps_patrol_init 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_patrol_init.sqf");
	mps_spawn_vehicle 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_vehicle.sqf");
	mps_object_offset		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_object_offset.sqf");
	mps_moveable_unload		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_moveable_unload.sqf");
	mps_injury_sys_init		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_ais_init.sqf");
	mps_backpack_dialog_upd		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_bkp_dialogupd.sqf");
	mps_lift_chopper_init 		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_liftchopper_init.sqf");
	mps_mission_sequence		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_mission_sequence.sqf");
	mps_replace_with_ace		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_replace_with_ace.sqf");
	mps_recruit_build_list		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_recruit_dialog.sqf");
	mps_recruit_create_new		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_recruit_create_unit.sqf");
	CREATE_OPFOR_SQUAD		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opforsquad.sqf");
	CREATE_OPFOR_ARMY		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opforarmy.sqf");
	CREATE_OPFOR_STATIC		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opforstatic.sqf");
	CREATE_OPFOR_SNIPERS		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opforsnipers.sqf");
	CREATE_OPFOR_PARADROP		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opforparadrop.sqf");
	CREATE_OPFOR_TOWER		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opfortower.sqf");
	CREATE_OPFOR_PATROLS		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opforpatrols.sqf");
	CREATE_OPFOR_AIRPATROLS		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_spawn_opforradar.sqf");
	CREATE_MOVEABLE_CONTAINER	= compile preprocessFileLineNumbers (mps_path+"func\mps_func_moveable_container.sqf");
	CREATE_MOVEABLE_TOWER		= compile preprocessFileLineNumbers (mps_path+"func\mps_func_moveable_tower.sqf");

// Dynamic BIS Object spawner
	BIS_fnc_dyno			= compile preprocessFileLineNumbers "ca\modules\dyno\data\scripts\objectMapper.sqf";

// BON Visualisation Adaption
	visual_settings_maxallowed_viewdist = 10000;
	vpos = viewdistance;
	GrassLayer = 1;

// Bon Recruitment Variables
	mps_group_maxsize = 10;
	mps_recruit_queue = [];

// Calling Public Event Handlers
	[] call compile preprocessFileLineNumbers (mps_path+"func\mps_func_ammobox_pevh.sqf");
	[] call compile preprocessFileLineNumbers (mps_path+"func\mps_func_rank_pevh.sqf");

// Begin Task sytem by Shuko
	[] call mps_tasks_init;

// Initialise Client and Server to begin calling Functions
	[] execVM (mps_path+"init_mps_server.sqf");
	[] execVM (mps_path+"init_mps_client.sqf");

// Declare MPS initialised
	mps_init = true;
